package connection

import (
	"fmt"
	"net"
)

const RTUNetwork = "rtu"

type RTUAddr struct {
	Address  string
	BaudRate int
	DataBits int
	StopBits int
	Parity   string
}

func NewRTUAddr(addr string, rate int, dataBits int, stopBits int, parity string) net.Addr {
	return &RTUAddr{
		Address:  addr,
		BaudRate: rate,
		DataBits: dataBits,
		StopBits: stopBits,
		Parity:   parity,
	}
}

func (r *RTUAddr) Network() string {
	return RTUNetwork
}

// String form of address (for example, "/dev/ttyS0|19200|8|1|N", "com1|19200|8|1|N")
func (r *RTUAddr) String() string {
	return fmt.Sprintf("%s|%d|%d|%d", r.Address, r.BaudRate, r.DataBits, r.StopBits)
}
